#include <vector>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <conio.h>
#include <thread>
#include <atomic>

using namespace std;

atomic_uint total_iterations;

vector<unsigned> v;

void scramble_vector(size_t total_elements)
{
	for (size_t i = 0;i<total_elements;++i)
		v.push_back(i);

	for_each(begin(v), end(v), [](unsigned i) {
		size_t rnd = rand()%v.size();
		unsigned swapper = v[i];
		v[i] = v[rnd];
		v[rnd] = swapper;
	});
}

void find_element(unsigned element)
{
	unsigned iterations = 0;
	stringstream ss;

	find_if(begin(v), end(v), [=, &iterations](const unsigned i) -> bool {
		++iterations;
		return (i==element);
	});
	total_iterations+= iterations;

	ss << "Thread #" << this_thread::get_id() << ": found after " << iterations << " iterations." << endl;
	cout << ss.str();
}

int main(int argc, char *argv[])
{
	cout.sync_with_stdio(true);

	total_iterations = 0;
	scramble_vector(1000);
	thread th(find_element, 0);
	find_element(100);
	th.join();

	cout << total_iterations << " total iterations." << endl;

	cout << "Press any key...";
	_getch();
}