#include <mutex>
#include <chrono>
#include <thread>
#include <iostream>
#include <sstream>
#include <conio.h>

using namespace std;

mutex mx;

void introduceRandomDelay(unsigned d)
{
	// simulates a delay between 0 and d seconds.
	this_thread::sleep_for(chrono::seconds(rand()%d));
}

void funcA()
{
	stringstream ss;
	for (int i = 0; i<3; ++i)
	{
		this_thread::sleep_for(chrono::seconds(1));

		ss.str("");
		ss << "funcA: locking with wait... " << endl;
		cout << ss.str();
		lock_guard<mutex> lg(mx);
		ss.str("");
		ss << "funcA: lock secured... " << endl;
		cout << ss.str();

		introduceRandomDelay(2);

		ss.str("");
		ss << "funcA: releasing lock." << endl;
		cout << ss.str();
	}
}

void funcB()
{
	int successful_attempts = 0;
	stringstream ss;
	for (int i = 0; i<5; ++i)
	{
		unique_lock<mutex> ul(mx, try_to_lock_t());
		if (ul)
		{
			++successful_attempts;

			ss.str("");
			ss << "funcB: lock attempt successful." << endl;
			cout << ss.str();

			introduceRandomDelay(3);

			ss.str("");
			ss << "funcB: releasing lock." << endl;
			cout << ss.str();
		} else {
			ss.str("");
			ss << "funcB: lock attempt unsuccessful. Hibernating..." << endl;
			cout << ss.str();
			this_thread::sleep_for(chrono::seconds(1));
		}
	}
	ss.str("");
	ss << "funcB: " << successful_attempts << " successful attempts." << endl;
	cout << ss.str();
}

int main()
{
	cout.sync_with_stdio(true);

	thread th(funcA);
	funcB();
	th.join();

	cout << "Press any key...";
	_getch();
}